package nl.iobyte.themepark.api.load.objects;

import nl.iobyte.themepark.ThemePark;
import nl.iobyte.themepark.api.ThemeParkAPI;
import nl.iobyte.themepark.api.attraction.objects.Attraction;
import nl.iobyte.themepark.api.config.ConfigurationManager;
import nl.iobyte.themepark.api.config.enums.StorageLocation;
import nl.iobyte.themepark.api.load.interfaces.IDataLoader;
import nl.iobyte.themepark.api.sign.objects.StatusSign;
import nl.iobyte.themepark.utils.LocationUtil;
import org.bukkit.Location;
import org.bukkit.block.Sign;
import java.util.List;

public class SignDataLoader implements IDataLoader {

    /**
     * Called when loading data
     */
    public void load() {
        ThemeParkAPI api = ThemePark.getInstance().getAPI();
        ConfigurationManager manager = api.getConfigurationManager();

        for(Attraction attraction : api.getAttractionService().getAttractions().values()) {
            if(attraction == null)
                continue;

            if(!manager.contains(StorageLocation.SIGN_DATA, "signs." + attraction.getID()))
                continue;

            List<String> locations = manager.getStringList(StorageLocation.SIGN_DATA, "signs." + attraction.getID());
            for(String string : locations) {
                Location location = LocationUtil.fromString(string);
                if(location == null)
                    continue;

                if(location.getBlock() == null)
                    continue;

                if(!(location.getBlock().getState() instanceof Sign))
                    continue;

                api.getSignManager().addSign(new StatusSign(attraction, location));
            }
        }
    }

}
