package nl.iobyte.themepark.api.menu.objects.handlers;

import nl.iobyte.menuapi.enums.Types;
import nl.iobyte.menuapi.interfaces.IActionHandler;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import java.util.List;

public class CommandMenuHandler implements IActionHandler {

    private final String command;

    public CommandMenuHandler(String command) {
        if(!command.startsWith("/"))
            command = "/"+command;

        this.command = command;
    }

    public String getID() {
        return "COMMAND";
    }

    public List<ClickType> getClickTypes() {
        return Types.NORMAL.getTypesList();
    }

    public void execute(Player player) {
        player.closeInventory();
        player.chat(command);
    }

}
