package nl.iobyte.themepark.commands.objects;

import java.util.HashMap;

public class Reflection {

    private static final HashMap<String, Class<?>> classes = new HashMap<>();

    public static Class<?> getClass(String path) {
        if(classes.containsKey(path))
            return classes.get(path);

        try {
            Class<?> clazz = Class.forName(path);
            classes.put(path, clazz);
            return clazz;
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
            classes.put(path, null);
            return null;
        }
    }

}