package nl.iobyte.themepark.commands.objects;

import com.sk89q.worldedit.Vector;
import com.sk89q.worldedit.bukkit.BukkitWorld;
import com.sk89q.worldguard.bukkit.WorldGuardPlugin;
import com.sk89q.worldguard.protection.ApplicableRegionSet;
import com.sk89q.worldguard.protection.managers.RegionManager;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.plugin.Plugin;
import java.lang.reflect.Method;

public class WGManager {

    private static String wgVerStr = null;
    private static WGManager instance = null;

    public static WGManager getInstance() {
        if (instance == null) {
            instance = new WGManager();
        }

        return instance;
    }

    public WorldGuardPlugin getWorldGuard() {
        Plugin plugin = Bukkit.getServer().getPluginManager().getPlugin("WorldGuard");
        if ((!(plugin instanceof WorldGuardPlugin)))
            return null;

        return (WorldGuardPlugin) plugin;
    }

    public RegionManager getRegionManager(World w) {
        if (getWgVer().contains("7.")) {
            try {
                Class<?> wgClass = Reflection.getClass("com.sk89q.worldguard.WorldGuard");
                if(wgClass == null)
                    return null;

                Object instance = wgClass.getDeclaredMethod("getInstance").invoke(null);
                Class<?> wgInstanceClass = instance.getClass();

                Object platform = wgInstanceClass.getDeclaredMethod("getPlatform").invoke(instance);
                Class<?> wgPlatformClass = platform.getClass();

                Object regionContainer = wgPlatformClass.getDeclaredMethod("getRegionContainer").invoke(platform);
                Class<?> wgRegionContainer = regionContainer.getClass();

                return (RegionManager) wgRegionContainer.getSuperclass()
                        .getMethod("get", com.sk89q.worldedit.world.World.class)
                        .invoke(regionContainer, new BukkitWorld(w));
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        } else {
            return getWorldGuard().getRegionManager(w);
        }

        return null;
    }

    public ApplicableRegionSet getApplicableRegionSet(Location loc) {
        if (getWgVer().contains("7.")) {
            try {
                RegionManager mngr = getRegionManager(loc.getWorld());

                Class<?> blockVector3 = Reflection.getClass("com.sk89q.worldedit.math.BlockVector3");
                if(blockVector3 == null)
                    return null;

                Method applicableRegions = mngr.getClass().getDeclaredMethod("getApplicableRegions", blockVector3);

                Method blockVectorAt = blockVector3.getDeclaredMethod("at", double.class, double.class, double.class);
                Object blockVector = blockVectorAt.invoke(null, loc.getX(), loc.getY(), loc.getZ());

                Object regionSet = applicableRegions.invoke(mngr, blockVector);

                return (ApplicableRegionSet) regionSet;
            } catch (Exception ex) {
                ex.printStackTrace();
                return null;
            }
        } else {
            return getRegionManager(loc.getWorld()).getApplicableRegions(new Vector(loc.getX(), loc.getY(), loc.getZ()));
        }
    }


    public String getWgVer() {
        if (wgVerStr == null)
            wgVerStr = Bukkit.getPluginManager().getPlugin("WorldGuard").getDescription().getVersion();

        return wgVerStr;
    }

}