package nl.iobyte.themepark.commands.subcommands;

import nl.iobyte.commandapi.arguments.StringArgument;
import nl.iobyte.commandapi.interfaces.ICommandExecutor;
import nl.iobyte.commandapi.objects.SubCommand;
import nl.iobyte.themepark.ThemePark;
import nl.iobyte.themepark.api.config.enums.StorageKey;
import nl.iobyte.themepark.api.menu.MenuService;
import nl.iobyte.themepark.scheduler.ThemeParkScheduler;
import org.bukkit.entity.Player;
import java.util.List;

public class MenuCommand extends SubCommand {

    public MenuCommand(String cmd) {
        super(new String[]{"menu"});

        addSyntax("/"+cmd+" menu")
                .setAllowConsole(false);

        addSyntax("/"+cmd+" menu status")
                .addArgument(new StringArgument("status"))
                .setAllowConsole(false);
    }

    public void onCommand(ICommandExecutor player, List<Object> objects, int i) {
        MenuService service = ThemePark.getInstance().getAPI().getMenuService();
        if(i == 0 && ThemePark.getInstance().getAPI().getConfigurationManager().getBoolean(StorageKey.MENU_ENABLED_MAIN)) {
            ThemeParkScheduler.runSync(() -> service.getMainMenu().open((Player) player.getOriginal()));
            return;
        }

        ThemeParkScheduler.runSync(() -> service.getStatusMenu().open((Player) player.getOriginal()));
    }

}
