package nl.iobyte.themepark.commands.subcommands.attraction;

import nl.iobyte.commandapi.objects.SubCommand;
import nl.iobyte.themepark.api.attraction.objects.Attraction;
import nl.iobyte.themepark.api.message.Text;
import nl.iobyte.themepark.commands.arguments.AttractionArgument;
import nl.iobyte.commandapi.interfaces.ICommandExecutor;
import org.bukkit.entity.Player;
import java.util.List;

public class AttractionLocationCommand extends SubCommand {

    public AttractionLocationCommand(String cmd)  {
        super("themepark.admin", "attraction", "location");

        addSyntax("/"+cmd+" attraction location <id>")
                .addArgument(new AttractionArgument())
                .setAllowConsole(false);
    }

    public void onCommand(ICommandExecutor  sender, List<Object> list, int i) {
        Attraction attraction = (Attraction) list.get(0);
        Player player = (Player) sender.getOriginal();
        attraction.setLocation(player.getLocation());
        player.sendMessage(Text.color("&6&lThemePark &f➢ &aSuccessfully changed the location of attraction &f"+attraction.getName()));
    }

}
