package nl.iobyte.themepark.commands.subcommands.region;

import nl.iobyte.commandapi.arguments.MessageArgument;
import nl.iobyte.commandapi.interfaces.ICommandExecutor;
import nl.iobyte.commandapi.objects.SubCommand;
import nl.iobyte.themepark.api.attraction.objects.Region;
import nl.iobyte.themepark.api.message.Text;
import nl.iobyte.themepark.commands.arguments.RegionArgument;
import java.util.List;

public class RegionNameCommand extends SubCommand {

    public RegionNameCommand(String cmd)  {
        super("themepark.admin", "region", "name");

        addSyntax("/"+cmd+" region name <id> <name>")
                .addArgument(new RegionArgument())
                .addArgument(new MessageArgument());
    }

    public void onCommand(ICommandExecutor  sender, List<Object> list, int i) {
        Region region = (Region) list.get(0);
        String name = (String) list.get(1);
        region.setName(name);
        sender.sendMessage(Text.color("&6&lThemePark &f➢ &aSuccessfully changed the name of region &f"+region.getName()));
    }

}
