package nl.iobyte.themepark.commands.subcommands.region;

import nl.iobyte.commandapi.interfaces.ICommandExecutor;
import nl.iobyte.commandapi.objects.SubCommand;
import nl.iobyte.themepark.ThemePark;
import nl.iobyte.themepark.api.attraction.objects.Region;
import nl.iobyte.themepark.api.message.Text;
import nl.iobyte.themepark.commands.arguments.RegionArgument;
import java.util.List;

public class RegionRemoveCommand extends SubCommand {

    public RegionRemoveCommand(String cmd)  {
        super("themepark.admin", "region", "remove");

        addSyntax("/"+cmd+" region remove <id>")
                .addArgument(new RegionArgument());
    }

    public void onCommand(ICommandExecutor  sender, List<Object> list, int i) {
        Region region = (Region) list.get(0);
        ThemePark.getInstance().getAPI().getAttractionService().removeRegion(region.getID());
        sender.sendMessage(Text.color("&6&lThemePark &f➢ &aSuccessfully removed region &f"+region.getName()));
    }

}
