package nl.iobyte.themepark.commands.subcommands.ridecount;

import nl.iobyte.commandapi.arguments.EnumArgument;
import nl.iobyte.commandapi.interfaces.ICommandExecutor;
import nl.iobyte.commandapi.objects.SubCommand;
import nl.iobyte.themepark.ThemePark;
import nl.iobyte.themepark.api.message.Text;
import nl.iobyte.themepark.api.ridecount.enums.TotalType;
import java.util.List;

public class RideCountChangeTotalTypeCommand extends SubCommand {

    public RideCountChangeTotalTypeCommand(String cmd)  {
        super("themepark.admin", "ridecount", "total_type");

        addSyntax("/"+cmd+" ridecount total_type <type>")
                .addArgument(new EnumArgument(TotalType.values()));
    }

    
    public void onCommand(ICommandExecutor  sender, List<Object> list, int i) {
        TotalType type = (TotalType) list.get(0);

        ThemePark.getInstance().getAPI().getRideCountService().setType(type);
        sender.sendMessage(Text.color("&6&lThemePark &f➢ Changed total type for ridecount to: &f"+type.toString()));
    }

}
