package nl.iobyte.themepark.commands.subcommands.status;

import com.cryptomorin.xseries.XMaterial;
import nl.iobyte.commandapi.arguments.EnumArgument;
import nl.iobyte.commandapi.interfaces.ICommandExecutor;
import nl.iobyte.commandapi.objects.SubCommand;
import nl.iobyte.themepark.api.attraction.enums.Status;
import nl.iobyte.themepark.api.message.Text;
import nl.iobyte.themepark.commands.arguments.MaterialArgument;
import java.util.List;

public class StatusMaterialCommand extends SubCommand {

    public StatusMaterialCommand(String cmd)  {
        super("themepark.admin", "status", "material");

        addSyntax("/"+cmd+" status material <status> <material>")
                .addArgument(new EnumArgument(Status.values()))
                .addArgument(new MaterialArgument());
    }

    
    public void onCommand(ICommandExecutor  sender, List<Object> list, int i) {
        Status status = (Status) list.get(0);
        XMaterial material = (XMaterial) list.get(1);

        status.setMaterial(material);
        sender.sendMessage(Text.color("&6&lThemePark &f➢ &aSuccessfully changed the material of status &f"+ status));
    }

}
