package nl.iobyte.themepark.commands.subcommands.status;

import nl.iobyte.commandapi.arguments.EnumArgument;
import nl.iobyte.commandapi.arguments.MessageArgument;
import nl.iobyte.commandapi.objects.SubCommand;
import nl.iobyte.themepark.api.attraction.enums.Status;
import nl.iobyte.themepark.api.message.Text;
import nl.iobyte.commandapi.interfaces.ICommandExecutor;
import java.util.List;

public class StatusNameCommand extends SubCommand {

    public StatusNameCommand(String cmd)  {
        super("themepark.admin", "status", "name");

        addSyntax("/"+cmd+" status name <id> <name>")
                .addArgument(new EnumArgument(Status.values()))
                .addArgument(new MessageArgument());
    }

    
    public void onCommand(ICommandExecutor  sender, List<Object> list, int i) {
        Status status = (Status) list.get(0);
        String name = (String) list.get(1);
        status.setName(name);
        sender.sendMessage(Text.color("&6&lThemePark &f➢ &aSuccessfully changed the name of status &f"+ status));
    }

}
