package nl.iobyte.themepark.traincarts;

import com.bergerkiller.bukkit.tc.controller.MinecartMember;
import com.bergerkiller.bukkit.tc.events.SignActionEvent;
import com.bergerkiller.bukkit.tc.events.SignChangeActionEvent;
import com.bergerkiller.bukkit.tc.signactions.SignAction;
import com.bergerkiller.bukkit.tc.signactions.SignActionType;
import com.bergerkiller.bukkit.tc.utils.SignBuildOptions;
import nl.iobyte.themepark.ThemePark;
import nl.iobyte.themepark.api.ThemeParkAPI;
import org.bukkit.entity.Player;
import java.util.ArrayList;

public class RideCountSign extends SignAction {

    @Override
    public boolean match(final SignActionEvent info) {
        return info.getLine(1).equalsIgnoreCase("ridecount") && !info.getLine(2).isEmpty() && !info.getLine(3).isEmpty();
    }

    @Override
    public void execute(final SignActionEvent info) {
        if (!info.isPowered())
            return;

        if (info.isTrainSign() && info.isAction(SignActionType.REDSTONE_ON, SignActionType.GROUP_ENTER) && info.hasGroup()) {
            ArrayList<Player> players = new ArrayList<>();
            for (final MinecartMember<?> member : info.getGroup())
                players.addAll(member.getEntity().getPlayerPassengers());

            count(players, info);
            return;
        }

        if (!info.isCartSign() || !info.isAction(SignActionType.REDSTONE_ON, SignActionType.MEMBER_ENTER) || !info.hasMember()) {
            if (info.isRCSign() && info.isAction(SignActionType.REDSTONE_ON)) {
                ArrayList<Player> players = new ArrayList<>();
                for (final MinecartMember<?> member : info.getGroup())
                    players.addAll(member.getEntity().getPlayerPassengers());

                count(players, info);
            }

            return;
        }

        if (!info.getMember().getEntity().isEmpty()) {
            ArrayList<Player> players = new ArrayList<>(info.getMember().getEntity().getPlayerPassengers());
            count(players, info);
        }
    }

    @Override
    public boolean build(SignChangeActionEvent event) {
        return SignBuildOptions.create()
                .setName(event.isCartSign() ? "cart ridecount sign" : "train ridecount sign")
                .setDescription("Add a count to a player for an attraction")
                .handle(event.getPlayer());
    }

    private void count(ArrayList<Player> players, SignActionEvent info) {
        String id = info.getLine(2);
        ThemeParkAPI api = ThemePark.getInstance().getAPI();
        if(!api.getAttractionService().hasAttraction(id))
            return;

        int amount = 1;
        try {
            amount = Integer.parseInt(info.getLine(3));
        } catch (Exception e) {
            e.printStackTrace();
        }

        for(Player player : players)
            api.getRideCountService().addCount(id, player.getUniqueId(), amount);
    }

}