package nl.iobyte.themepark.utils;

import net.md_5.bungee.api.chat.BaseComponent;
import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.chat.HoverEvent;
import net.md_5.bungee.api.chat.TextComponent;
import nl.iobyte.themepark.ThemePark;
import nl.iobyte.themepark.api.attraction.objects.Attraction;
import nl.iobyte.themepark.api.config.enums.StorageKey;
import nl.iobyte.themepark.api.config.enums.StorageLocation;
import nl.iobyte.themepark.api.message.MessageKey;
import nl.iobyte.themepark.api.message.Text;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class StatusMessage {

    public static void broadcast(Attraction attraction) {
        HashMap<String, String> change = new HashMap<>();
        change.put("{name}", attraction.getName());
        ClickEvent click = new ClickEvent(ClickEvent.Action.RUN_COMMAND, "/"+ThemePark.getInstance().getAPI().getConfigurationManager().getString(StorageKey.CMD)+" attraction warp "+attraction.getID());
        HoverEvent hover = new HoverEvent(HoverEvent.Action.SHOW_TEXT, TextComponent.fromLegacyText(Text.color(ThemePark.getInstance().getAPI().getConfigurationManager().getString(StorageLocation.MESSAGE, "attraction.changed.hover"))));
        if(hover.getValue()[0].toPlainText().isEmpty())
            hover = null;

        BaseComponent message = parseTP("attraction.changed."+attraction.getStatus().toString(), change, click, hover);
        if(message == null)
            return;

        for(Player player : Bukkit.getOnlinePlayers())
            player.spigot().sendMessage(message);
    }

    private static BaseComponent parseTP(String path, HashMap<String, String> change, ClickEvent click, HoverEvent hover) {
        String message = ThemePark.getInstance().getAPI().getConfigurationManager().getString(StorageLocation.MESSAGE, path);
        message = message.replace("{prefix}", MessageKey.PREFIX.getMessage());
        for(Map.Entry<String, String> entrySet : change.entrySet())
            message = message.replace(entrySet.getKey(), entrySet.getValue());

        message = Text.color(message);
        if(click != null) {
            String regex = "(.*)\\[TP\\](.*?)\\[/TP\\](.*)";
            Pattern p = Pattern.compile(regex);
            Matcher m = p.matcher(message);
            while (m.find()) {
                String first = m.group(1);
                String middle = m.group(2);
                String last = m.group(3);

                BaseComponent[] components = TextComponent.fromLegacyText(first);
                BaseComponent component = components[0];
                for(int i = 1; i < components.length; i++)
                    component.addExtra(components[i]);

                components = TextComponent.fromLegacyText(middle);
                BaseComponent compClick = components[0];
                for(int i = 1; i < components.length; i++)
                    compClick.addExtra(components[i]);

                compClick.setClickEvent(click);
                if(hover != null)
                    compClick.setHoverEvent(hover);

                component.addExtra(compClick);
                components = TextComponent.fromLegacyText(last);
                BaseComponent compLast = components[0];
                for (BaseComponent baseComponent : components) component.addExtra(baseComponent);

                component.addExtra(compLast);
                return component;
            }
        }

        BaseComponent[] components = TextComponent.fromLegacyText(message);
        BaseComponent component = components[0];
        for(int i = 1; i < components.length; i++)
            component.addExtra(components[i]);

        return component;
    }

}
